package fr.cnam.helloworld;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class MainActivity extends ActionBarActivity {

	private TextView myTextView = null;
	private TextView myTextView2 = null;
	private Button myButton = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// le layout
		setContentView(R.layout.activity_main);
		
		// les vues
		myButton = (Button) findViewById(R.id.myButton);
		
		myTextView = (TextView) findViewById(R.id.myTextView);
		String text = getString(R.string.hello_world);
		myTextView.setText(text);

		// les images
		Drawable d = getResources().getDrawable(R.drawable.ic_launcher);
		ImageView image = (ImageView) findViewById(R.id.imageView);
		image.setImageDrawable(d);

		// autres
		getResources().getColor(R.color.abc_search_url_text_holo);
		getResources().getDimension(R.dimen.activity_horizontal_margin);

		readAssets();
		doSomeLogStuff();
		
		myButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				myButton_onClick(v);
			}
		});
	}

	static final String STATE_SCORE = "playerScore";
	private int currentScore = 10;
	
	private void myButton_onClick(View v) {
		myTextView.setText(getText(R.string.after_click));		
	}
	
	@Override
	protected void onSaveInstanceState (Bundle outState) {
		// Save the user's current game state
		outState.putInt(STATE_SCORE, currentScore);
	    
	    // Always call the superclass so it can save the view hierarchy state
	    super.onSaveInstanceState(outState);
	}
	
	@Override
	protected void onRestoreInstanceState(Bundle savedInstanceState) {
	    // Always call the superclass so it can restore the view hierarchy
	    super.onRestoreInstanceState(savedInstanceState);
	   
	    // Restore state members from saved instance
	    currentScore = savedInstanceState.getInt(STATE_SCORE);
	}
	
	private void readAssets() {
		myTextView2 = (TextView) findViewById(R.id.myTextView2);

		String line;
		StringBuilder sb = new StringBuilder();

		BufferedReader input = null;
		try {
			input = new BufferedReader(new InputStreamReader(getAssets().open(
					"hello.txt")));

			while ((line = input.readLine()) != null) {
				sb.append(line);
			}
		} catch (IOException e) {
			if (input != null) {
				throw new RuntimeException(e);
			}
		} finally {
			try {
				if (input != null) {
					input.close();
				}
			} catch (IOException e) {
				throw new RuntimeException(e);
			}
		}

		myTextView2.setText(sb.toString());
	}
	
	private void doSomeLogStuff() {
		Log.d(MainActivity.class.getName(), "My debug log");
		Log.i(MainActivity.class.getName(), "My info log");
		Log.w(MainActivity.class.getName(), "My warning log");
		Log.e(MainActivity.class.getName(), "My error log");
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

	// etc ....

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		int id = item.getItemId();
		if (id == R.id.action_settings) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

}
