package fr.cnam.in01.ormlite;

import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

import com.j256.ormlite.android.apptools.OrmLiteBaseActivity;
import com.j256.ormlite.dao.RuntimeExceptionDao;
import com.j256.ormlite.stmt.QueryBuilder;
import com.j256.ormlite.stmt.Where;

import fr.cnam.in01.ormlite.businessModel.Book;
import fr.cnam.in01.ormlite.data.LibraryDBHelper;
import fr.cnam.in01.ormlite.R.id;

import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class MainActivity extends OrmLiteBaseActivity<LibraryDBHelper> {

	private TextView textview;

	/**
	 Called when the activity is first created.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

        textview = (TextView)findViewById(id.textview);

		doSomeDBStuff();
		doOtherDBStuff();
	}

	private void doSomeDBStuff() {
		RuntimeExceptionDao<Book, Integer> bookDAO = getHelper().getBookDataDao();

		Book book1 = new Book(-1, "Croc Blanc", "2010034031", 248);
		Book book2 = new Book(-1, "L'appel de la forêt", "2253039861", 158);

		bookDAO.create(book1);
		bookDAO.create(book2);
		
		List<Book> books = bookDAO.queryForAll();
		for (Book book : books) {
			textview.append("READ ALL : " + book.toString() + "\n");
		}

		textview.append("\n");
		textview.append("READ BY SELECT : " +  bookDAO.queryForId(1).toString() + "\n");
	}

	@SuppressWarnings("unchecked")
	private void doOtherDBStuff() {
		try {
			RuntimeExceptionDao<Book, Integer> bookDAO = getHelper().getBookDataDao();

			QueryBuilder<Book, Integer> queryBuilder = bookDAO.queryBuilder();
			Where<Book, Integer> where = queryBuilder.where();

			where.and(
				where.eq("title", "Croc Blanc"),
				where.or(
					where.eq("nbPage", 248),
					where.eq("nbPage", 317)
				)
			);
			textview.append("\n");
			textview.append("WHERE : " + where.getStatement() + "\n");

			textview.append("\n");
			List<Book> books = bookDAO.query(queryBuilder.prepare());
			for (Book book : books) {
				textview.append("READ BY QUERY " + book.toString());
			}

		} catch (SQLException ex) {
			Logger.getLogger(MainActivity.class.getName()).log(Level.SEVERE, null, ex);
		}

	}

}
