/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.cnam.in01.ormlite.data;

import java.sql.SQLException;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import com.j256.ormlite.android.apptools.OrmLiteSqliteOpenHelper;
import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.RuntimeExceptionDao;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.TableUtils;

import fr.cnam.in01.ormlite.businessModel.Book;

/**
 <p>
 @author cyann
 */
public class LibraryDBHelper extends OrmLiteSqliteOpenHelper {

	public static final String DB_NAME = "Library.db";
	public static final int DB_VERSION = 4;

	public LibraryDBHelper(Context context) {
		super(context, DB_NAME, null, DB_VERSION);
	}

	@Override
	public void onCreate(SQLiteDatabase sqld, ConnectionSource cs) {
		try {
			TableUtils.createTable(connectionSource, Book.class);
		} catch (SQLException ex) {
			throw new RuntimeException(ex);
		}
	}

	@Override
	public void onUpgrade(SQLiteDatabase sqld, ConnectionSource cs, int i, int i1) {
		try {
			TableUtils.dropTable(connectionSource, Book.class, true);
			TableUtils.createTable(connectionSource, Book.class);
		} catch (SQLException ex) {
			throw new RuntimeException(ex);
		}
	}

	private Dao<Book, Integer> simpleDao = null;
	private RuntimeExceptionDao<Book, Integer> simpleRuntimeDao = null;

	public Dao<Book, Integer> getBookDao() throws SQLException {
		if (simpleDao == null) {
			simpleDao = getDao(Book.class);
		}
		return simpleDao;
	}

	public RuntimeExceptionDao<Book, Integer> getBookDataDao() {
		if (simpleRuntimeDao == null) {
			simpleRuntimeDao = getRuntimeExceptionDao(Book.class);
		}
		return simpleRuntimeDao;
	}

	@Override
	public void close() {
		super.close();
		simpleDao = null;
		simpleRuntimeDao = null;
	}
}
