/* 
 * Copyright (C) 2014 cyann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.cnam.in01.sqlite;

import java.util.List;

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.widget.SimpleCursorAdapter;
import android.util.Log;
import android.widget.TextView;
import fr.cnam.in01.sqlite.R.id;
import fr.cnam.in01.sqlite.businessModel.Book;
import fr.cnam.in01.sqlite.data.BookDAO;
import fr.cnam.in01.sqlite.data.LibraryDataSource;

public class MainActivity extends Activity
{
	
	private TextView textview;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        textview = (TextView)findViewById(id.textview);
        
		doSomeDBStuff();
    }
	
	private void doSomeDBStuff() {
		// instancing
		LibraryDataSource datasource = new LibraryDataSource(this);
		BookDAO bookDAO = datasource.newBookDAO();
		datasource.open();
		
		// create new pojos
		Book book1 = new Book(-1, "Croc Blanc", "2010034031", 248);
		Book book2 = new Book(-1, "L'appel de la forêt", "2253039861", 158);
		
		// store them to database
		bookDAO.create(book1);
		bookDAO.create(book2);
		
		// read all
		List<Book> books = bookDAO.readAll();
		for (Book book : books) {
			textview.append("READ ALL : " + book.toString() + "\n");
		}
		
		// read only one
		Book anotherBook = bookDAO.read(new Book(book1.getId()));
		textview.append("\n");
		textview.append("READ BY SELECT : " + anotherBook.toString() + "\n");

		// delete db
		datasource.getDB().execSQL("DELETE FROM Book");
		
		datasource.close();	
	}
}
