/* 
 * Copyright (C) 2014 cyann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.cnam.in01.sqlite.common;

import android.database.sqlite.SQLiteDatabase;
import java.util.List;

/**
 <p>
 @author cyann
 */
public abstract class DataAccessObject<P extends Pojo> {

	private final DataSource datasource;

	public DataAccessObject(DataSource datasource) {
		this.datasource = datasource;
	}

	public SQLiteDatabase getDB() {
		return datasource.getDB();
	}
	
	// CRUD
	public abstract P create(P pojo);

	public abstract P read(P pojo);

	public abstract P update(P pojo);

	public abstract void delete(P pojo);

}
