/* 
 * Copyright (C) 2014 cyann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package fr.cnam.in01.sqlite.data;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

/**
 * <p>
 * 
 * @author cyann
 */
public class LibraryDBHelper extends SQLiteOpenHelper {

	public static final String DB_NAME = "Library.db";
	public static final int DB_VERSION = 5;

	// constructor
	public LibraryDBHelper(Context context) {
		super(context, DB_NAME, null, DB_VERSION);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		db.execSQL(BookDAO.getQueryCreate());
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		// Management by successive upgrades
		// newVersion is 4 !
		int delta = newVersion - oldVersion;
		if (delta >= 3) {
			// upgrate to version 2
		}

		if (delta >= 2) {
			// upgrate to version 3
		}

		if (delta >= 1) {
			// upgrate to version 4
		}
	}

}
