package fr.cnam.in01.in01_fragments;

import android.app.Activity;
import android.app.Fragment;
import android.app.FragmentTransaction;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import fr.cnam.in01.in01_fragments.MenuFragment.MenuChangeEvent;

public class MainActivity extends Activity {

	private Fragment fragment1;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main_activity);
		
		Intent intent = getIntent();
		if (intent.getExtras() != null) {
			Class<? extends Fragment> frClass = (Class<? extends Fragment>) intent
					.getExtras().get("fragment");
			
			if (frClass != null) {
				fragment1 = loadFragment(R.id.placeholder1, frClass);
			}
		} else {
			fragment1 = loadFragment(R.id.placeholder1, MenuFragment.class);
		}

		if (fragment1 instanceof MenuFragment) {

			MenuFragment menuFragment = (MenuFragment) fragment1;

			menuFragment.setOnMenuChange(new MenuChangeEvent() {

				@Override
				public void menuChanger(int id) {
					switch (id) {
					case R.id.button1:
						navigate(MenuFragment.class);
						break;
					case R.id.button2:
						navigate(MainFragment.class);
						break;
					}
				}
			});
		}

	}

	private void navigate(Class<? extends Fragment> frClass) {
		View placeHolder = findViewById(R.id.placeholder2);

		// verify if fragment place holder exists
		if (placeHolder == null) {
			Intent intent = new Intent();
			intent.setClass(this, MainActivity.class);
			intent.putExtra("fragment", frClass);
			startActivity(intent);
		} else {
			loadFragment(R.id.placeholder2, frClass);
		}

	}

	private Fragment loadFragment(int placeholder,
			Class<? extends Fragment> frClass) {
		Fragment fragment = null;
		try {
			fragment = frClass.newInstance();
			// reflexion

			FragmentTransaction ft = getFragmentManager().beginTransaction();
			ft.replace(placeholder, fragment);
			ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_FADE);
			ft.addToBackStack(null);
			ft.commit();

		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return fragment;
	}

}
