package fr.cnam.in01.in01_fragments;

import android.app.Fragment;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;

public class MenuFragment extends Fragment {

	private Button button1, button2, button3;
	private MenuChangeEvent menuChanged;

	public interface MenuChangeEvent {

		void menuChanger(int id);

	}

	public void setOnMenuChange(MenuChangeEvent menuChanged) {
		this.menuChanged = menuChanged;
	}

	private void fireMenuChanged(int id) {
		if (this.menuChanged != null) {
			this.menuChanged.menuChanger(id);
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		View view = inflater.inflate(R.layout.menu_fragment, container, false);

		button1 = (Button) view.findViewById(R.id.button1);
		button2 = (Button) view.findViewById(R.id.button2);
		button3 = (Button) view.findViewById(R.id.button3);

		return view;
	}

	@Override
	public void onResume() {
		super.onResume();

		button1.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonX_clicked(v);
			}
		});

		button2.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonX_clicked(v);
			}
		});

		button3.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonX_clicked(v);
			}
		});
	}

	private void buttonX_clicked(View v) {
		fireMenuChanged(v.getId());
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onDestroyView() {
		super.onDestroyView();
	}

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
	}

	@Override
	public void onSaveInstanceState(Bundle outState) {
		// TODO Auto-generated method stub
		super.onSaveInstanceState(outState);
	}

}
