package fr.cnam.pecheurduleman.businessLogicLayer;

import java.util.List;

import fr.cnam.pecheurduleman.bean.Bait;
import fr.cnam.pecheurduleman.bean.Brand;
import fr.cnam.pecheurduleman.dataAccessLayer.BaitDAO;
import fr.cnam.pecheurduleman.dataAccessLayer.BrandDAO;
import fr.cnam.pecheurduleman.dataAccessLayer.ListAll;
import fr.cnam.pecheurduleman.dataAccessLayer.db4o.BaitDb4o;
import fr.cnam.pecheurduleman.dataAccessLayer.db4o.BrandDb4o;
import fr.cnam.pecheurduleman.tool.StringUtil;

public class BaitBO implements ListAll<Bait> {

	private final BaitDAO baitDao;
	private final BrandDAO brandDao;

	public BaitBO() {
		super();
		baitDao = new BaitDb4o();
		brandDao = new BrandDb4o();
	}

	public void createOrUpdate(Bait bean) {
		// format entry
		bean.setName(StringUtil.capitalizeFirst(bean.getName()));
		bean.getBrand().setName(
				StringUtil.capitalizeFirst(bean.getBrand().getName()));

		// search ref and set pointer
		Brand brand = brandDao.find(bean.getBrand());
		if (brand == null) {
			brandDao.create(bean.getBrand());
		} else {
			bean.setBrand(brand);
		}

		// verify that fish does not already exists on db
		Bait existing = baitDao.find(new Bait(bean.getName(), null, 0f, 0f, 0f));
		if (existing == null) {
			// create
			baitDao.create(bean);
		} else {
			// update
			baitDao.update(bean, existing);
		}

	}

	@Override
	public List<Bait> listAll() {
		return baitDao.listAll();
	}

}
