package fr.cnam.pecheurduleman.view;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import fr.cnam.pecheurduleman.R;
import fr.cnam.pecheurduleman.bean.Bait;
import fr.cnam.pecheurduleman.bean.Brand;
import fr.cnam.pecheurduleman.businessLogicLayer.BaitBO;
import fr.cnam.pecheurduleman.businessLogicLayer.BrandBO;
import fr.cnam.pecheurduleman.view.tool.Converter;
import fr.cnam.pecheurduleman.view.tool.DataAdapter;

public class BaitFragment extends Fragment {

	private AutoCompleteTextView textName, textBrand;
	private EditText textPrice, textSize, textWeight;
	private Button buttonSave, buttonCancel;

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {

		View view = inflater.inflate(R.layout.fragment_bait, container, false);

		textName = (AutoCompleteTextView) view.findViewById(R.id.textBait);
		textBrand = (AutoCompleteTextView) view.findViewById(R.id.textBrand);
		textPrice = (EditText) view.findViewById(R.id.textPrice);
		textSize = (EditText) view.findViewById(R.id.textSize);
		textWeight = (EditText) view.findViewById(R.id.textWeight);

		buttonSave = (Button) view.findViewById(R.id.buttonSave);
		buttonCancel = (Button) view.findViewById(R.id.buttonCancel);

		buttonSave.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonSave_onClick(v);
			}
		});

		buttonCancel.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonCancel_onClick(v);
			}
		});

		return view;
	}

	// event handling
	private void buttonSave_onClick(View v) {
		// create beans
		Bait bait = new Bait(textName.getText().toString(), new Brand(textBrand
				.getText().toString()), Converter.tryParse(textPrice.getText()
				.toString(), 0f), Converter.tryParse(textSize.getText()
				.toString(), 0f), Converter.tryParse(textWeight.getText()
				.toString(), 0f));
		new BaitBO().createOrUpdate(bait);

		prepareForm();
	}

	private void buttonCancel_onClick(View v) {
		prepareForm();
	}

	// event handling
	private void prepareForm() {
		textName.setText("");
		textName.setAdapter(new DataAdapter<Bait>(this.getActivity(),
				android.R.layout.simple_dropdown_item_1line, new BaitBO()));

		textBrand.setText("");
		textBrand.setAdapter(new DataAdapter<Brand>(this.getActivity(),
				android.R.layout.simple_dropdown_item_1line, new BrandBO()));

	}

}
