package fr.cnam.pecheurduleman.view;

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import fr.cnam.pecheurduleman.R;
import fr.cnam.pecheurduleman.bean.Family;
import fr.cnam.pecheurduleman.bean.Fish;
import fr.cnam.pecheurduleman.businessLogicLayer.FamilyBO;
import fr.cnam.pecheurduleman.businessLogicLayer.FishBO;
import fr.cnam.pecheurduleman.view.tool.DataAdapter;

public class FishFragment extends Fragment {

	private AutoCompleteTextView textName = null;
	private AutoCompleteTextView textFamily = null;

	
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container,
			Bundle savedInstanceState) {
		
		LinearLayout content = new LinearLayout(this.getActivity());
		content.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.MATCH_PARENT,
				LinearLayout.LayoutParams.MATCH_PARENT));
		content.setOrientation(LinearLayout.VERTICAL);


		// add controls
		// add label / fish name pair
		TextView label1 = new TextView(this.getActivity());
		label1.setTextSize(TypedValue.COMPLEX_UNIT_SP,21);
		label1.setText(getText(R.string.fish_name));
		content.addView(label1);

		textName = new AutoCompleteTextView(this.getActivity());
		textName.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.MATCH_PARENT,
				LinearLayout.LayoutParams.WRAP_CONTENT));
		content.addView(textName);

		// add label / fish familly pair
		TextView label2 = new TextView(this.getActivity());
		label2.setTextSize(TypedValue.COMPLEX_UNIT_SP,21);
		label2.setText(getText(R.string.fish_familly));
		content.addView(label2);

		textFamily = new AutoCompleteTextView(this.getActivity());
		textFamily.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.MATCH_PARENT,
				LinearLayout.LayoutParams.WRAP_CONTENT));
		content.addView(textFamily);

		// action layout
		LinearLayout layoutAction = new LinearLayout(this.getActivity());
		layoutAction.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.MATCH_PARENT,
				LinearLayout.LayoutParams.MATCH_PARENT));
		layoutAction.setGravity(Gravity.BOTTOM | Gravity.CENTER_HORIZONTAL);
		layoutAction.setOrientation(LinearLayout.HORIZONTAL);
		content.addView(layoutAction);

		// add save button
		Button buttonSave = new Button(this.getActivity());
		buttonSave.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT,
				LinearLayout.LayoutParams.WRAP_CONTENT));
		buttonSave.setText(getText(R.string.global_button_save));
		layoutAction.addView(buttonSave);

		// manage event
		buttonSave.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonSave_onClick(v);
			}
		});

		// add cancel button
		Button buttonCancel = new Button(this.getActivity());
		buttonCancel.setLayoutParams(new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT,
				LinearLayout.LayoutParams.WRAP_CONTENT));
		buttonCancel.setText(getText(R.string.global_button_cancel));
		layoutAction.addView(buttonCancel);

		// manage event
		buttonCancel.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				buttonCancel_onClick(v);
			}
		});

		prepareForm();
		
		return content;
	}

	// event handling
	private void buttonSave_onClick(View v) {
		// create beans
		Fish fish = new Fish(textName.getText().toString(), new Family(
				textFamily.getText().toString()));
		new FishBO().createOrUpdate(fish);
		
		prepareForm();
	}

	private void buttonCancel_onClick(View v) {
		
	}

	private void prepareForm() {
		textName.setText("");
		textName.setAdapter(new DataAdapter<Fish>(this.getActivity(),
				android.R.layout.simple_dropdown_item_1line, new FishBO()));
		
		textFamily.setText("");
		textFamily.setAdapter(new DataAdapter<Family>(this.getActivity(),
				android.R.layout.simple_dropdown_item_1line, new FamilyBO()));
		
	}
}
