package fr.cnam.pecheurduleman.view;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.GoogleMap.InfoWindowAdapter;
import com.google.android.gms.maps.GoogleMap.OnInfoWindowClickListener;
import com.google.android.gms.maps.MapView;
import com.google.android.gms.maps.MapsInitializer;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;

import fr.cnam.pecheurduleman.R;

public class PlaceMapFragment extends Fragment {

	private static final String TAG = PlaceMapFragment.class.getName();

	private MapView mapView;
	private GoogleMap map;

	@Override
	public View onCreateView(final LayoutInflater inflater,
			ViewGroup container, Bundle savedInstanceState) {

		View v = inflater.inflate(R.layout.fragment_map, container, false);

		mapView = (MapView) v.findViewById(R.id.mapview);
		mapView.onCreate(savedInstanceState);

		// Gets to GoogleMap from the MapView and does initialization stuff
		map = mapView.getMap();
		// map.getUiSettings().setMyLocationButtonEnabled(true);
		// map.setMyLocationEnabled(true);

		// Needs to call MapsInitializer before doing any CameraUpdateFactory
		// calls
		MapsInitializer.initialize(this.getActivity());

		// position
		LatLng annemasse = new LatLng(46.193253, 6.2341579);
		LatLng portChoiseul = new LatLng(46.290144, 6.1657870);
		LatLng corsierPort = new LatLng(46.265341, 6.2115669);


		map.addMarker(new MarkerOptions()
				.position(annemasse)
				.title("Ma maison")
				.snippet("J'habite Annemasse")
				/*.icon(BitmapDescriptorFactory
						.fromResource(R.drawable.ic_launcher))*/);

		map.setInfoWindowAdapter(new InfoWindowAdapter() {

			@Override
			public View getInfoWindow(Marker marker) {
				return null;
			}

			@Override
			public View getInfoContents(Marker marker) {
				View v = inflater.inflate(R.layout.map_info_window, null);

				TextView title = (TextView) v.findViewById(R.id.info_title);
				title.setText(marker.getTitle());

				TextView snippet = (TextView) v.findViewById(R.id.info_snippet);
				snippet.setText(marker.getSnippet());

				return v;
			}
		});

		
		map.setOnInfoWindowClickListener(new OnInfoWindowClickListener() {

			@Override
			public void onInfoWindowClick(Marker marker) {
				Log.i(PlaceMapFragment.class.getName(), "On a cliqué sur "
						+ marker.getTitle() + " [" + marker.getSnippet() + "]");
			}
		});
		/*
		map.addCircle(new CircleOptions()
	    .center(annemasse)
	    .radius(1000) // en metre
	    .strokeWidth(5).strokeColor(Color.GRAY));

		map.addCircle(new CircleOptions()
	    .center(portChoiseul)
	    .radius(1000) // en metre
	    .strokeWidth(5).strokeColor(Color.GRAY));

		map.addPolyline((new PolylineOptions())
            .add(annemasse, portChoiseul, corsierPort, annemasse)
            .width(5).color(Color.BLUE)
            .geodesic(true));
		*/
		//map.addTileOverlay(options);
		
		
		   // positionnement
		map.moveCamera(CameraUpdateFactory.newLatLngZoom(annemasse, 15));

		// animation
		map.animateCamera(CameraUpdateFactory.zoomTo(10), 2000, null);

		return v;
	}

	@Override
	public void onResume() {
		mapView.onResume();
		super.onResume();
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
		mapView.onDestroy();
	}

	@Override
	public void onLowMemory() {
		super.onLowMemory();
		mapView.onLowMemory();
	}
}
