package fr.cnam.helloworld.test;

import android.test.ActivityInstrumentationTestCase2;
import android.test.TouchUtils;
import android.test.ViewAsserts;
import android.test.suitebuilder.annotation.MediumTest;
import android.test.suitebuilder.annotation.SmallTest;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.TextView;
import fr.cnam.helloworld.MainActivity;

public class ActivityTest extends  ActivityInstrumentationTestCase2<MainActivity>{

	public ActivityTest() {
		super(MainActivity.class);
	}

	private MainActivity activity = null;
	private TextView myTextView = null;
	private Button myButton = null;
	
	@Override
    protected void setUp() throws Exception {
		super.setUp();
		activity = getActivity();
		myTextView = (TextView) activity.findViewById(fr.cnam.helloworld.R.id.myTextView);
		myButton = (Button)activity.findViewById(fr.cnam.helloworld.R.id.myButton);
	}
	
	@SmallTest
	public void testPreconditions() {
	    assertNotNull("activity is null", activity);
	    assertNotNull("myTextView is null", myTextView);
	    assertNotNull("myButton is null", myButton);
	}
	
	@MediumTest
	public void testMyTextView_layout() {
	    final View decorView = activity.getWindow().getDecorView();
	    ViewAsserts.assertOnScreen(decorView, myTextView);
	    
	    final ViewGroup.LayoutParams layoutParams = myTextView.getLayoutParams();
	    
	    assertNotNull(layoutParams);
	    assertEquals(layoutParams.width, WindowManager.LayoutParams.WRAP_CONTENT);
	    assertEquals(layoutParams.height, WindowManager.LayoutParams.WRAP_CONTENT);
	}
	
	@MediumTest
	public void testMyButton_click() {
	    String initialText = activity.getString(fr.cnam.helloworld.R.string.hello_world);
	    String expectedText = activity.getString(fr.cnam.helloworld.R.string.after_click);

	    assertEquals(initialText, myTextView.getText());

	    TouchUtils.clickView(this, myButton);
	    
	    assertEquals(expectedText, myTextView.getText());
	}
}
